       ;Program to generate a MARQUEE around the video
 ;display. Works on Model 1 or 3.
 	ORG	0C000H
 MARQ	CALL	01C9H		;clear the video
 	LD	HL,3C00H	;top right corner
 	LD	B,32		;draw top line
 DRW	LD	(HL),140	;set graphic block
 	INC	HL		;point to next
 	LD	(HL),80H	;set graphic space
 	INC	HL		;point to next
 	DJNZ	DRW		;loop for 32 time
 	LD	HL,3C7FH	;end of next line
 	LD	DE,64		;offset between lines
 	LD	B,7		;loop counter
 DRW1	LD	(HL),179	;show graphic
 	ADD	HL,DE		;point to next
 	LD	(HL),140	;different block
 	ADD	HL,DE		;find next
 	DJNZ	DRW1		;loop til done
 	LD	HL,3FFFH	;end of video
 	LD	B,32		;bytes to draw
 DRW2	LD	(HL),140	;graphic block
 	DEC	HL		;back up one
 	LD	(HL),80H	;set space
 	DEC	HL		;back up another
 	DJNZ	DRW2		;loop til done
 	LD	HL,3F80H	;second botm left
 	LD	B,7		;lines to do
 	LD	DE,64		;offset between lines
 DRW3	LD	(HL),179	;set graphic
 	OR	A		;clear carry
 	SBC	HL,DE		;find previous
 	LD	(HL),140	;graphic
 	OR	A		;again
 	SBC	HL,DE		;find previous
 	DJNZ	DRW3		;loop til done
 ROTATE	LD	HL,3C00H	;start of video
 	LD	B,64		;bytes to scan
 R1	CALL	DELAY		;wait a bit
 	LD	A,(HL)		;get a byte
 	CP	140		;graphic?
 	JR	Z,GRAPH		;go if graphic
 	LD	(HL),140	;else its a space
 R1A	INC	HL		;point to next
 	DJNZ	R1		;loop til done
 	CALL	2BH		;do keyboard scan
 	OR	A		;look for keypress
 	JP	NZ,402DH	;dos if keyed
 	JR	ROT2		;go on to second line
 GRAPH	LD	(HL),80H	;replace with space
 	JR	R1A		;and return
 ROT2	LD	HL,3C7FH	;point to end line
 	LD	B,14		;bytes to loop through
 R2	CALL	DELAY		;wait a bit
 	LD	A,(HL)		;get a byte
 	CP	140		;graphic?
 	JR	Z,GR2		;go if yes
 	LD	(HL),140	;else make it one
 R2A	LD	DE,64		;offset to next
 	ADD	HL,DE		;find next line
 	DJNZ	R2		;and ocntinue
 	JR	ROT3		;continue to bottom
 GR2	LD	(HL),179	;different block
 	JR	R2A		;and return
 ROT3	LD	HL,3FFFH	;end of video
 	LD	B,64		;bytes to loop
 R3	CALL	DELAY		;wait a bit
 	LD	A,(HL)		;get a byte
 	CP	140		;graphic?
 	JR	Z,GR3		;go if yes
 	LD	(HL),140	;else make it one
 R3A	DEC	HL		;back up one
 	DJNZ	R3		;loop til done
 	JR	ROT4		;and do last line
 GR3	LD	(HL),80H	;replace the block
 	JR	R3A		;and return
 ROT4	LD	HL,3F80H	;start of last
 	LD	DE,64		;offset used
 	LD	B,14		;lines to check
 R4	CALL	DELAY		;wait a bit
 	LD	A,(HL)		;get a byte
 	CP	140		;block?
 	JR	Z,GR4		;go if yes
 	LD	(HL),140	;else make it one
 R4A	OR	A		;clear the carry
 	SBC	HL,DE		;find previous line
 	DJNZ	R4		;loop til done
 	JP	ROTATE		;continue now
 GR4	LD	(HL),179	;different block
 	JR	R4A		;and return
 DELAY	PUSH	BC		;save counter
 	LD	BC,55		;else reset value
 DELAY1	CALL	60H		;do rom delay
 	POP	BC		;restore count
 	RET			;back to routine
 	END	MARQ

